#include <stdio.h>
#include <string.h>
#include "scsipart.h"

ulong_t max_freeblock;
ulong_t used_capacity;
ulong_t free_capacity;
ulong_t total_capacity;

static char *prop[] = {
  "N",
  "gps",
  "gp\",
};

void disppart(int id)
{
  int no;
  ulong_t last_usedblock;

  max_freeblock = used_capacity = 0UL;

  /*  FORMAT.X ́A擪 0x20 _ZN^ 1MB PʂŊmۂ */
  last_usedblock = SKIP_SECT;
  total_capacity = (parttab.total - SKIP_SECT) & MB_MASK;

  printf("\n----------------------------------------\n"
           " dev: osname :̈摮: 擪 :TCY(MB)\n"
           "----:--------:--------:------:----------\n");

  for (no = 0; no < PCNT_MAX; no++) {
    /* p[eBVe[u͘AĂ */
    if (parttab.ent[no].count == 0) break;

    /* 󂫗̈\ */
    if (parttab.ent[no].start > last_usedblock) {
      printf("sd%d :        :  Free  :%06x:%5dMB\n",
             id, last_usedblock,
             (parttab.ent[no].start - last_usedblock)/1024);
      max_freeblock = max(max_freeblock, parttab.ent[no].start - last_usedblock);
    }

    /* p[eBV\ */
    printf("sd%d%c:%-8.8s:%8s:%06x:%5dMB\n",
           id, partname(no),
           parttab.ent[no].name,
           prop[parttab.ent[no].flag],
           parttab.ent[no].start,
           parttab.ent[no].count/1024);

    /* evZ */
    used_capacity += parttab.ent[no].count;
    last_usedblock = parttab.ent[no].start + parttab.ent[no].count;
  }

  /* ŌɃt[ubNꍇ̕\ */
  if ((total_capacity+SKIP_SECT) > last_usedblock) {
    printf("sd%d :        :  Free  :%06x:%5dMB\n",
           id, last_usedblock,
           (total_capacity+SKIP_SECT - last_usedblock)/1024);
    max_freeblock = max(max_freeblock, (total_capacity+SKIP_SECT) - last_usedblock);
  }
  printf("----------------------------------------\n");

  /* SxSI scsiformat.x ́Aall w肷ƑSẴNX^gp\ɂ̂
     ̈̑傫 MB Pʂł͂ȂȂ邱ƂɒӁB */
  free_capacity = total_capacity - (used_capacity&MB_MASK);

  printf("Se: %dMB  gp: %dMB  󂫗e: %dMB  A󂫗e: %dMB\n",
	 total_capacity/1024, used_capacity/1024, free_capacity/1024,  max_freeblock/1024);
}
