#include <stdio.h>
#include <string.h>
#include "scsipart.h"

uchar_t	sectbuf[LOGSEC_LEN];
ptab_s	parttab;


int testunit(int id)
{
  int sts;

  if (!scsi_available[id] || (sts = ck_scsi_testunit(id)) < 0) {
    fprintf(stderr, "ID%d ̃foCX͐ڑĂ܂\n", id);
    return -1;
  }

  /* MO Ȃǂł͂P good ԂȂ̂ retry */
  if (sts & SCSI_STS_CHKCOND) {
    if (ck_scsi_testunit(id) & SCSI_STS_CHKCOND) {
      fprintf(stderr, "ID%d ̃foCX͎gpł܂\n", id);
      return -1;
    }
  }
  return 0;
}


int getpart(int id)
{
  if (testunit(id)) return -1;

  if (scsi_read_sector(id, (void*)sectbuf, PART_SECTNO) < 0) {
    fprintf(stderr, "ID%d ̃foCX̃p[eBVǂݍ߂܂ł.\n", id);
    return -1;
  }

  memcpy((void*)&parttab, (void*)sectbuf, sizeof parttab);

  if (strncmp(parttab.pid, PID_STR, PID_LEN)) {
    fprintf(stderr, "ID%d ̃foCX Human68k FORMAT.X ŃtH[}bgĂ܂.\n", id);
    return -1;
  }
  return 0;
}
