#include <stdio.h>
#include <string.h>
#include "scsipart.h"

char rwbuf[RWSIZ];


void image_get(int id)
{
  int no, size, offset, part_max;
  char* name;
  FILE *fp;

  if ((part_max = countpart() - 1) < 0) {
    fprintf(stderr, "̈悪mۂĂ܂\n");
    return;
  }

  no = inputc("C[Wö(a%c) -->", part_max > 7 ? 'h' : partname(part_max));
  if (no < 'a' || no > (part_max > 7 ? 'h' : partname(part_max)) || no == 'c') {
    fprintf(stderr, "̈w肪sł.\n");
    return;
  }
  no = partnumber(no);

  size = parttab.ent[no].count;
  if (!size) {
    fprintf(stderr, "w肳ꂽ̈͊mۂĂ܂.\n");
    return;
  }
  offset = parttab.ent[no].start;
  name = input("sd%d%c ̃C[W(%dMB)o܂.\nt@C͂ĉ -->", id, partname(no), size/1024);
  if (!strlen(name)) return;
  if (!(fp = fopen(name, "wb"))) {
    fprintf(stderr, "t@CI[vł܂ł.\n");
    return;
  }

  if (scsi_read_capacity(id) == NULL) {
    fprintf(stderr, "ZN^TCY擾ł܂ł.\n");
    return;
  }

  print_guide("o", size);
  while (size > 0)
    {
      if (scsi_readext(id, rwbuf, offset, RWSIZ/LOGSEC_LEN) < 0) {
        fprintf(stderr, "os...\n");
        return;
      }
      if (fwrite(rwbuf, 1, RWSIZ, fp) <= 0) {
        fprintf(stderr, "݂Ɏs܂.\n");
        fclose(fp);
        return;
      }
      offset += RWSIZ/LOGSEC_LEN;
      size   -= RWSIZ/LOGSEC_LEN;
      fputc('o', stdout), fflush(stdout);
    }
  fclose(fp);
  printf(" oI.\n");
}
