#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "scsipart.h"

#define	uch	unsigned char
#define	_isspace(c)	((uch)(c)==(uch)' '||(uch)(c)==(uch)'\t'||(uch)(c)==(uch)'\r'||(uch)(c)==(uch)'\n')
static char linebuffer[256];

static char* input_line(void)
{
	char* ptr;
	char* endptr;

	fflush(stdin);

	/* Ps */
	if (fgets(ptr = linebuffer, sizeof linebuffer, stdin) == NULL) {
		exit(0);
	}

	/* 擪̃Xy[XXLbv */
	while (_isspace(*ptr)) ptr++;

	/* Ō̃Xy[XXLbv */
	endptr = ptr + strlen(ptr);
	while (--endptr >= ptr && _isspace(*endptr)) *endptr = '\0';

	/* IR}h */
	if (*ptr == 'Q' || *ptr == 'q') exit(0);

	/* R}hs */
	if (*ptr == '!') {
		fputc('\n', stdout);
		system(ptr+1);
		fputc('\n', stdout);
	}

	return ptr;
}

char* input(char* fmt, ...)
{
  char* ptr;
  va_list ap;

  va_start(ap, fmt);
  while (1) {
	vprintf(fmt, ap);

	ptr = input_line();
	if (*ptr != '!') break;
  }
  va_end(ap);
  return ptr;
}


int	inputc(char* fmt, ...)
{
  char* ptr;
  va_list ap;

  va_start(ap, fmt);
  while (1) {
	vprintf(fmt, ap);

	ptr = input_line();
	if (*ptr != '!') break;
  }
  va_end(ap);
  return *ptr;
}
