#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "scsipart.h"


static int check_part(void)
{
  int no;

  for (no = 0; no < PCNT_MAX; no++) {
    if (parttab.ent[no].count == 0) return no;
  }
  fprintf(stderr, "̈悪tł. ЂƂȂƊmۂł܂\n");
  return -1;
}

static int free_part(void)
{
  int no;
  ulong_t last = SKIP_SECT;

  for (no = 0; no < PCNT_MAX; no++) {
    if (parttab.ent[no].count == 0 || parttab.ent[no].start > last) return no;
    last = parttab.ent[no].start + parttab.ent[no].count;
  }
  return -1;
}

void makepart(int id)
{
  int count, no, max_size;
  char* ptr;
  pent_s ptmp;

  if (free_capacity == 0UL) {
    fprintf(stderr, "sd%d ɂ͋󂫗eʂ܂.\n", id);
    return;
  }

  /* mۂĂ̈搔߂ */
  if ((count = check_part()) < 0) return;

  /* 󂫗̈T */
  no = free_part();

  /* ̈̐擪߂ */
  ptmp.start = no ? parttab.ent[no-1].start + parttab.ent[no-1].count : SKIP_SECT;

  /* ̈̍őTCY߂ */
  if (count == no) {
    max_size = total_capacity+SKIP_SECT - ptmp.start;
  }
  else {
    max_size = parttab.ent[no].start - ptmp.start;
  }
  printf("sd%d%c ͍ő %dMB mۉ\ł.\n", id, partname(no), max_size / 1024);

  /* OS ̂̐ݒ */
  ptr = input("OS (8oCgȓ) -->");
  if (strlen(ptr) > 8) {
    fprintf(stderr, "8oCgȓłȂΊmۂł܂.\n");
    return;
  }
  memset(ptmp.name, ' ', PNAM_MAX);
  memcpy(ptmp.name, ptr, strlen(ptr));

  /* mۂ̈̑傫 */
  ptr = input("MB mۂ܂(1-%d, all)? -->", max_size/1024);
  if (strcmp(ptr, "all") == 0) {
    ptmp.count = (ulong_t)max_size;
  }
  else {
    ptmp.count = atol(ptr)*1024;
  }
  if (ptmp.count && ptmp.count > (ulong_t)max_size) {
    fprintf(stderr, "%dMB ȓłȂƊmۂł܂.\n", max_size/1024);
    return;
  }

  ptr = input("̈摮: 0.N 1.gps 2.gp\ -->");
  ptmp.flag = atoi(ptr);
  if ((unsigned)ptmp.flag > 2) {
    fprintf(stderr, "G[.\n");
    return;
  }

  used_capacity += ptmp.count;
  free_capacity -= ptmp.count;
  if (parttab.used < ptmp.start + ptmp.count) {
     parttab.used = ptmp.start + ptmp.count;
  }

  if (count > no) {
    /* Gg}錄Ԃ */
    memmove(&parttab.ent[no+1], &parttab.ent[no], (count - no)*sizeof(pent_s));
  }
  memcpy(&parttab.ent[no], &ptmp, sizeof(pent_s));

  putpart(id);
}
