#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "scsipart.h"

int countpart(void)
{
  int no;

  for (no = 0; no < PCNT_MAX; no++) {
    if (parttab.ent[no].count == 0) break;
  }
  return no;
}

void change_attr(int id)
{
  int part_max, no, flag;

  if ((part_max = countpart() - 1) < 0) {
    fprintf(stderr, "̈悪mۂĂ܂\n");
    return;
  }

  printf("ύẌ(a%c)", part_max > 7 ? 'h' : partname(part_max));
  no = inputc(" -->");
  if (no < 'a' || no > (part_max > 7 ? 'h' : partname(part_max)) || no == 'c') {
    fprintf(stderr, "̈w肪sł.\n");
    return;
  }
  no = partnumber(no);

  flag = inputc("̈摮: 0.N 1.gps 2.gp\ -->") - '0';
  if ((unsigned)flag > 2) {
    fprintf(stderr, "G[.\n");
    return;
  }

  parttab.ent[no].flag = flag;
  putpart(id);
}


void change_name(int id)
{
  int part_max, no;
  char* ptr;

  if ((part_max = countpart() - 1) < 0) {
    fprintf(stderr, "̈悪mۂĂ܂\n");
    return;
  }

  no = inputc("OŜύẌ(a%c) -->", part_max > 7 ? 'h' : partname(part_max));
  if (no < 'a' || no > (part_max > 7 ? 'h' : partname(part_max)) || no == 'c') {
    fprintf(stderr, "̈w肪sł.\n");
    return;
  }
  no = partnumber(no);

  ptr = input("OS (8oCgȓ) -->");
  if (strlen(ptr) > 8) {
    fprintf(stderr, "8oCgȓłȂΊmۂł܂.\n");
    return;
  }

  memset(parttab.ent[no].name, ' ', PNAM_MAX);
  memcpy(parttab.ent[no].name, ptr, strlen(ptr));
  putpart(id);
}


void relpart(int id)
{
  int part_max, no, yn;

  if ((part_max = countpart() - 1) < 0) {
    fprintf(stderr, "̈悪mۂĂ܂\n");
    return;
  }

  no = inputc("̈(a%c) -->", part_max > 7 ? 'h' : partname(part_max));
  if (no < 'a' || no > (part_max > 7 ? 'h' : partname(part_max)) || no == 'c') {
    fprintf(stderr, "̈w肪sł.\n");
    return;
  }
  no = partnumber(no);

  yn = inputc("{ɗ̈ sd%d%c Ăł(y/n)? ", id, partname(no));
  if (yn != 'Y' && yn != 'y') {
    printf("~܂\n");
    return;
  }

  if (part_max > no) {
    memmove(&parttab.ent[no], &parttab.ent[no+1], (part_max - no)*sizeof(pent_s));
    memset(&parttab.ent[part_max], 0, sizeof(pent_s));
  }
  else {
    memset(&parttab.ent[no], 0, sizeof(pent_s));
    if (no) {
      parttab.used = parttab.ent[no-1].start + parttab.ent[no-1].count;
    }
  }

  putpart(id);
}

